# extconf.rb
# $Id: extconf.rb,v 1.21 2001/12/03 09:46:30 ttate Exp $

$CPPFLAGS = $CPPFLAGS || ""
$LDFLAGS  = $LDFLAGS || ""

require "mkmf"

if( ARGV.include?("--help") )
  print <<EOF
  --with-fltk-dir        specify the fltk install prefix.
  --with-fltk-include    specify the directory which contains fltk header files.
  --with-fltk-lib        specify the directory which contains fltk library.
  --with-jpeg-dir        specify the jpeg install prefix.
  --with-jpeg-include    specify the directory which contains jpeg header files.
  --with-jpeg-lib        specify the directory which contains jpeg library.
  --with-png-dir         specify the png install prefix.
  --with-png-include     specify the directory which contains png header files.
  --with-png-lib         specify the directory which contains png library.
  --with-z-dir           specify the z install prefix.
  --with-z-include       specify the directory which contains z header files.
  --with-z-lib           specify the directory which contains z library.
  --with-gl-dir          specify the GL install prefix.
  --with-gl-include      specify the directory which contains GL header files.
  --with-gl-lib          specify the directory which contains GL library.
  --with-x-dir           specify the directory for X11.
  --with-x-include       specify the directory for X11 header files.
  --with-x-lib           specify the directory for X11 library.
  --disable-gl
  --disable-jpeg
  --disable-png
  --disable-z
EOF
#  --with-flek-dir        specify the flek install prefix.
#  --with-flek-include    specify the directory which contains flek header files.
#  --with-flek-lib        specify the directory which contains flek library.
#  --disable-flek
  exit(0)
end

dir_config("fltk", "/usr/local/include", "/usr/local/lib")
#dir_config("flek", "/usr/local/include", "/usr/local/lib")
dir_config("gl", "/usr/local/include", "/usr/local/lib")
dir_config("x", "/usr/X11R6/include", "/usr/X11R6/lib")
dir_config("jpeg","/usr/include", "/usr/lib")
dir_config("png","/usr/include", "/usr/lib")
dir_config("z","/usr/include", "/usr/lib")

if( have_header("X11/X.h") && have_library("X11") && have_library("Xext") )
  # for X11
  if( !have_header("X11/Xlocale.h") )
    have_header("locale.h")
  end
  if( !have_func("_Xsetlocale") )
    have_func("setlocale")
  end
else
  if( ! (have_library("gdi32") && have_library("wsock32")) )
    exit(0)
  end
end

# for GL
use_gl = false
enable_gl = enable_config("gl") || true
if( enable_gl )
  if( (have_library("GL") && have_library("GLU")) ||
      (have_library("opengl32") && have_library("glu32")) )
    have_library("fltk_gl") # required by fltk-1.1.x
    use_gl = true
  end
end

# libxunicode: http://www.ab.wakwak.com/~tino/jatk/fltk/
# libXutf8:    http://oksdi.ch/fltk-utf/
use_xunicode = use_utf8 = false
if( have_library("fltk", "fl_set_xic_focus__FP9Fl_Widgetiiiiii") && have_library("xunicode") )
  use_xunicode = true
else
  if( have_header("FL/fl_utf8.h") && have_library("Xutf8") )
    use_utf8 = true
  end
end

#libflek
=begin
use_flek = false
enable_flek = enable_config("flek") || true
if enable_flek
  use_flek = true if have_library("flek_ui")
  # use_flek = true if have_library("flek_ui") && have_library("flek_core")
end
=end

#libjpeg
use_jpeg = false
enable_jpeg = enable_config("jpeg") || true
if enable_jpeg
    use_jpeg = true if have_library("jpeg")
end

#libpng
use_png = false
enable_png = enable_config("png") || true
if enable_png
    use_png = true if have_library("png")
end

#libz
use_z = false
enable_z = enable_config("z") || true
if enable_z
    use_z = true if have_library("z")
end

# for FLTK
have_fl_h    = have_header("FL/Fl.H")
have_libfltk = have_library("fltk")

$CPPFLAGS += " -DUSE_GL" if use_gl
# $CPPFLAGS += " -DUSE_FLEK" if use_flek
$CPPFLAGS += " -DUSE_UTF8" if use_utf8
$CPPFLAGS += " -DUSE_XUNICODE" if use_xunicode
$CPPFLAGS += " -DUSE_JPEG" if use_jpeg
$CPPFLAGS += " -DUSE_PNG" if use_png
$CPPFLAGS += " -DUSE_Z" if use_z

have_func("rb_hash_delete")

if( have_fl_h && have_libfltk )
  create_makefile("rubyfltk")
end
