/* -*- C++ -*-
 * $Id: flbrowser.h,v 1.5 2001/09/27 03:17:57 ttate Exp $
 */

#ifndef RBFLBROWSER_H
#define RBFLBROWSER_H

/*
 * select macro is defined in ruby-x.x.x/win32/win32.h.
 * This definition conflicts with Fl_Browser::select.
 *                                  Thanks Lorien Dunn
 */
#ifdef select
# undef select
#endif

#include <FL/Fl_Browser_.H>
#include <FL/Fl_Browser.H>
#include <FL/Fl_Hold_Browser.H>
#include <FL/Fl_Multi_Browser.H>
#include <FL/Fl_Select_Browser.H>
#include "flgroup.h"

class RBFLBrowser_ : public Fl_Browser_
{
public:
  RBFLBrowser_(int x, int y, int w, int h, const char *label = 0)
    : Fl_Browser_(x,y,w,h,label){};
  RBFL_CALLERS(Fl_Browser_);

  virtual void * item_first() const {
    VALUE obj = rb_fltk_objmap_aref((Fl_Widget*)this);
    VALUE ret = rb_funcall(obj, rb_intern("item_first"), 0);
    return (ret == Qnil) ? NULL : (void*)ret;
  };
  virtual void * item_next(void *item) const {
    VALUE obj = rb_fltk_objmap_aref((Fl_Widget*)this);
    VALUE ret = rb_funcall(obj, rb_intern("item_next"), 1, (VALUE)item);
    return (ret == Qnil) ? NULL : (void*)ret;
  };
  virtual void * item_prev(void *item) const {
    VALUE obj = rb_fltk_objmap_aref((Fl_Widget*)this);
    VALUE ret = rb_funcall(obj, rb_intern("item_prev"), 1, (VALUE)item);
    return (ret == Qnil) ? NULL : (void*)ret;
  };
  virtual int item_height(void *item) const {
    VALUE obj = rb_fltk_objmap_aref((Fl_Widget*)this);
    if( !item ) item = (void*)Qnil;
    return NUM2INT(rb_funcall(obj, rb_intern("item_height"), 1, (VALUE)item));
  };
  virtual int item_width(void *item) const {
    VALUE obj = rb_fltk_objmap_aref((Fl_Widget*)this);
    if( !item ) item = (void*)Qnil;
    return NUM2INT(rb_funcall(obj, rb_intern("item_width"), 1, (VALUE)item));
  };
  virtual void item_draw(void *item, int x, int y, int w, int h) const {
    VALUE obj = rb_fltk_objmap_aref((Fl_Widget*)this);
    if( !item ) item = (void*)Qnil;
    rb_funcall(obj, rb_intern("item_draw"), 5,
	       (VALUE)item, INT2NUM(x), INT2NUM(y), INT2NUM(w), INT2NUM(h));
  };
};

RBFL_CLASS(Browser);
RBFL_CLASS(Hold_Browser);
RBFL_CLASS(Multi_Browser);
RBFL_CLASS(Select_Browser);

extern VALUE rb_cFLBrowser_;
extern VALUE rb_cFLBrowser;
extern VALUE rb_cFLHold_Browser;
extern VALUE rb_cFLMulti_Browser;
extern VALUE rb_cFLSelect_Browser;

extern "C" void Init_flbrowser(void);

#endif /* RBFLBOX_H */
