/* -*- C++ -*-
 * $Id: flbutton.cc,v 1.16 2001/11/25 17:04:34 ttate Exp $
 */

#include "fltk.h"
#include "flenum.h"
#include "flbutton.h"

VALUE rb_cFLButton;
VALUE rb_cFLCheck_Button;
VALUE rb_cFLLight_Button;
VALUE rb_cFLRepeat_Button;
VALUE rb_cFLReturn_Button;
VALUE rb_cFLRound_Button;

static FN_S_NEW(Button);
WIDGET_FNS(Button);
static FN_INIT2(Button,size,{
  if( rb_block_given_p() ){
    rb_fl_callback(self);
  };
});
static FN_GETSET_INT_RENAME(Button,buttontype,type);
static FN_CALL(Button,clear);
static FN_GETSET_INT(Button,value);
static FN_GETSET_ENUM(Button,Fl_Boxtype,down_box);
static FN_CALL(Button,setonly);
static FN_GETSET_INT(Button,shortcut);

static FN_S_NEW(Check_Button);
WIDGET_FNS(Check_Button);

static FN_S_NEW(Light_Button);
WIDGET_FNS(Light_Button);

static FN_S_NEW(Repeat_Button);
WIDGET_FNS(Repeat_Button);

static FN_S_NEW(Return_Button);
WIDGET_FNS(Return_Button);

static FN_S_NEW(Round_Button);
WIDGET_FNS(Round_Button);

extern "C" void
Init_flbutton(){
  /* Button Types */
  NUMCONST(TOGGLE_BUTTON);
  NUMCONST(RADIO_BUTTON);
  
  rb_cFLButton = rb_define_class_under(rb_mFLTK, "Button", rb_cFLWidget);
  DEF_S_METHOD(Button,new,-1);
  DEF_WIDGET_METHODS(Button);
  DEF_METHOD(Button, buttontype,-1);
  RB_DEF_METHOD(rb_cFLButton, "button_type", rb_FLButton_buttontype, -1);
  DEF_METHOD(Button,initialize,-1);
  DEF_METHOD_EQ(Button, value, -1);
  DEF_METHOD_EQ(Button, down_box, -1);
  DEF_METHOD(Button, setonly, 0);
  DEF_METHOD(Button, clear, 0);
  DEF_METHOD_EQ(Button, shortcut, -1);

  rb_cFLCheck_Button = rb_define_class_under(rb_mFLTK, "CheckButton", rb_cFLButton);
  DEF_S_METHOD(Check_Button,new,-1);
  DEF_WIDGET_METHODS(Check_Button);

  rb_cFLLight_Button = rb_define_class_under(rb_mFLTK, "LightButton", rb_cFLButton);
  DEF_S_METHOD(Light_Button,new,-1);
  DEF_WIDGET_METHODS(Light_Button);

  rb_cFLRepeat_Button = rb_define_class_under(rb_mFLTK, "RepeatButton", rb_cFLButton);
  DEF_S_METHOD(Repeat_Button,new,-1);
  DEF_WIDGET_METHODS(Repeat_Button);

  rb_cFLReturn_Button = rb_define_class_under(rb_mFLTK, "ReturnButton", rb_cFLButton);
  DEF_S_METHOD(Return_Button,new,-1);
  DEF_WIDGET_METHODS(Return_Button);

  rb_cFLRound_Button = rb_define_class_under(rb_mFLTK, "RoundButton", rb_cFLButton);
  DEF_S_METHOD(Round_Button,new,-1);
  DEF_WIDGET_METHODS(Round_Button);
};
