#include "fltk.h"
#include "flenum.h"
#include "version.h"

extern "C" void
Init_flenum()
{
  NUMCONST(RBFL_MINOR_VERSION);
  NUMCONST(RBFL_MAJOR_VERSION);
  NUMCONST(RBFL_PATCH_VERSION);
  STRCONST(RBFL_VERSION);

  NUMCONST(MAJOR_VERSION);
  NUMCONST(MINOR_VERSION);
  NUMCONST(PATCH_VERSION);
  DOUBLECONST(VERSION);

  /* Fl_Labeltype */
  NUMCONST(NORMAL_LABEL);
  NUMCONST(NO_LABEL);
  NUMCONST(SYMBOL_LABEL);
  NUMCONST(SHADOW_LABEL);
  NUMCONST(ENGRAVED_LABEL);
  NUMCONST(EMBOSSED_LABEL);
  // NUMCONST(BITMAP_LABEL);
  // NUMCONST(PIXMAP_LABEL);
  // NUMCONST(IMAGE_LABEL);
  // NUMCONST(MULTI_LABEL);
  NUMCONST(FREE_LABELTYPE);

  /* Fl_Event */
  NUMCONST(NO_EVENT);
  NUMCONST(PUSH);
  NUMCONST(RELEASE);
  NUMCONST(ENTER);
  NUMCONST(LEAVE);
  NUMCONST(DRAG);
  NUMCONST(FOCUS);
  NUMCONST(UNFOCUS);
  NUMCONST(KEYBOARD);
  NUMCONST(CLOSE);
  NUMCONST(MOVE);
  NUMCONST(SHORTCUT);
  NUMCONST(DEACTIVATE);
  NUMCONST(ACTIVATE);
  NUMCONST(HIDE);
  NUMCONST(SHOW);
  NUMCONST(PASTE);
  NUMCONST(SELECTIONCLEAR);

  /* Callback "When" conditions */
  NUMCONST(WHEN_NEVER);
  NUMCONST(WHEN_CHANGED);
  NUMCONST(WHEN_NOT_CHANGED);
  NUMCONST(WHEN_RELEASE);
  NUMCONST(WHEN_ENTER_KEY);
  NUMCONST(WHEN_RELEASE_ALWAYS);
  NUMCONST(WHEN_ENTER_KEY_ALWAYS);

  /* Fl::event_button() values */
  NUMCONST(LEFT_MOUSE);
  NUMCONST(MIDDLE_MOUSE);
  NUMCONST(RIGHT_MOUSE);

  /* Fl::event_key() values */
  /*
   * how do we add these constants?
   * can we make the name with under-score?
   */
  KEYCONST(BackSpace);
  KEYCONST(Tab);
  KEYCONST(Enter);
  KEYCONST(Pause);
  KEYCONST(Scroll_Lock);
  KEYCONST(Escape);
  KEYCONST(Home);
  KEYCONST(Left);
  KEYCONST(Up);
  KEYCONST(Right);
  KEYCONST(Down);
  KEYCONST(Page_Up);
  KEYCONST(Page_Down);
  KEYCONST(End);
  KEYCONST(Print);
  KEYCONST(Insert);
  /* KEYCONST(Menu); *//* duplicated */
  KEYCONST(Num_Lock);
  KEYCONST(KP);
  KEYCONST(KP_Enter);
  KEYCONST(KP_Last);
  KEYCONST(F);
  KEYCONST(F_Last);
  KEYCONST(Shift_L);
  KEYCONST(Shift_R);
  KEYCONST(Control_L);
  KEYCONST(Control_R);
  KEYCONST(Caps_Lock);
  KEYCONST(Meta_L);
  KEYCONST(Meta_R);
  KEYCONST(Alt_L);
  KEYCONST(Alt_R);
  KEYCONST(Delete);

  /* Fl::event_state() values */
  NUMCONST(SHIFT);
  NUMCONST(CAPS_LOCK);
  NUMCONST(CTRL);
  NUMCONST(ALT);
  NUMCONST(NUM_LOCK);
  NUMCONST(META);
  NUMCONST(SCROLL_LOCK);
  NUMCONST(BUTTON1);
  NUMCONST(BUTTON2);
  NUMCONST(BUTTON3);

  /* Alignment values */
  NUMCONST(ALIGN_CENTER);
  NUMCONST(ALIGN_TOP);
  NUMCONST(ALIGN_BOTTOM);
  NUMCONST(ALIGN_LEFT);
  NUMCONST(ALIGN_RIGHT);
  NUMCONST(ALIGN_CLIP);
  NUMCONST(ALIGN_WRAP);
  NUMCONST(ALIGN_TOP_LEFT);
  NUMCONST(ALIGN_TOP_RIGHT);
  NUMCONST(ALIGN_BOTTOM_LEFT);
  NUMCONST(ALIGN_BOTTOM_RIGHT);
  NUMCONST(ALIGN_LEFT_TOP);
  NUMCONST(ALIGN_RIGHT_TOP);
  NUMCONST(ALIGN_LEFT_BOTTOM);
  NUMCONST(ALIGN_RIGHT_BOTTOM);
  NUMCONST(ALIGN_INSIDE);

  /* Fonts */
  NUMCONST(HELVETICA);
  NUMCONST(HELVETICA_BOLD);
  NUMCONST(HELVETICA_ITALIC);
  NUMCONST(HELVETICA_BOLD_ITALIC);
  NUMCONST(COURIER);
  NUMCONST(COURIER_BOLD);
  NUMCONST(COURIER_ITALIC);
  NUMCONST(COURIER_BOLD_ITALIC);
  NUMCONST(TIMES);
  NUMCONST(TIMES_BOLD);
  NUMCONST(TIMES_ITALIC);
  NUMCONST(TIMES_BOLD_ITALIC);
  NUMCONST(SYMBOL);
  NUMCONST(SCREEN);
  NUMCONST(SCREEN_BOLD);
  NUMCONST(ZAPF_DINGBATS);
  NUMCONST(FREE_FONT);
  NUMCONST(BOLD);
  NUMCONST(ITALIC);

  /* Colors */
  NUMCONST(BLACK);
  NUMCONST(RED);
  NUMCONST(GREEN);
  NUMCONST(YELLOW);
  NUMCONST(BLUE);
  NUMCONST(MAGENTA);
  NUMCONST(CYAN);
  NUMCONST(WHITE);
  NUMCONST(SELECTION_COLOR);
  NUMCONST(GRAY);
  NUMCONST(GRAY0);
  NUMCONST(DARK3);
  NUMCONST(DARK2);
  NUMCONST(DARK1);
  NUMCONST(LIGHT1);
  NUMCONST(LIGHT2);
  NUMCONST(LIGHT3);

  /* Cursors */
  NUMCONST(CURSOR_DEFAULT);
  NUMCONST(CURSOR_ARROW);
  NUMCONST(CURSOR_CROSS);
  NUMCONST(CURSOR_WAIT);
  NUMCONST(CURSOR_INSERT);
  NUMCONST(CURSOR_HAND);
  NUMCONST(CURSOR_HELP);
  NUMCONST(CURSOR_MOVE);
  NUMCONST(CURSOR_NS);
  NUMCONST(CURSOR_WE);
  NUMCONST(CURSOR_NWSE);
  NUMCONST(CURSOR_NESW);
  NUMCONST(CURSOR_NONE);

  /* FD "When" conditions */
  NUMCONST(READ);
  NUMCONST(WRITE);
  NUMCONST(EXCEPT);

  /* Damage Masks */
  NUMCONST(DAMAGE_CHILD);
  NUMCONST(DAMAGE_EXPOSE);
  NUMCONST(DAMAGE_SCROLL);
  NUMCONST(DAMAGE_OVERLAY);
  NUMCONST(DAMAGE_ALL);
  
  /* Box Types */
  NUMCONST(NO_BOX);
  NUMCONST(FLAT_BOX);
  NUMCONST(UP_BOX);
  NUMCONST(DOWN_BOX);
  NUMCONST(UP_FRAME);
  NUMCONST(DOWN_FRAME);
  NUMCONST(THIN_UP_BOX);
  NUMCONST(THIN_DOWN_BOX);
  NUMCONST(THIN_UP_FRAME);
  NUMCONST(THIN_DOWN_FRAME);
  NUMCONST(ENGRAVED_BOX);
  NUMCONST(EMBOSSED_BOX);
  NUMCONST(ENGRAVED_FRAME);
  NUMCONST(EMBOSSED_FRAME);
  NUMCONST(BORDER_BOX);
  NUMCONST(BORDER_FRAME);
/*
These need to be handled differently because they have leading 
underlines ???
  _FL_SHADOW_BOX,
  _FL_SHADOW_FRAME,
  _FL_ROUNDED_BOX,	
  _FL_RSHADOW_BOX,
  _FL_ROUNDED_FRAME,	
  _FL_RFLAT_BOX,
  _FL_ROUND_UP_BOX,	
  _FL_ROUND_DOWN_BOX,
  _FL_DIAMOND_UP_BOX,	
  _FL_DIAMOND_DOWN_BOX,
  _FL_OVAL_BOX,		
  _FL_OSHADOW_BOX,
  _FL_OVAL_FRAME,	
  _FL_OFLAT_BOX,
*/

  /* Orientation Types */
  NUMCONST(HORIZONTAL);
  NUMCONST(VERTICAL);

  /* Slider Types */
  NUMCONST(VERT_SLIDER);
  NUMCONST(HOR_SLIDER);
  NUMCONST(VERT_FILL_SLIDER);
  NUMCONST(HOR_FILL_SLIDER);
  NUMCONST(VERT_NICE_SLIDER);
  NUMCONST(HOR_NICE_SLIDER);

  /* fl_line_style() */
  NUMCONST(SOLID);
  NUMCONST(DASH);
  NUMCONST(DOT);
  NUMCONST(DASHDOT);
  NUMCONST(DASHDOTDOT);
  NUMCONST(CAP_FLAT);
  NUMCONST(CAP_ROUND);
  NUMCONST(CAP_SQUARE);
  NUMCONST(JOIN_MITER);
  NUMCONST(JOIN_ROUND);
  NUMCONST(JOIN_BEVEL);
};
