/* -*- C++ -*-
 * $Id: flimage.h,v 1.2 2001/12/04 16:58:33 ttate Exp $
 */

#ifndef RBFLIMAGE_H
#define RBFLIMAGE_H

#include <FL/Fl_Image.H>
#include <FL/Enumerations.H>

#if FL_MAJOR_VERSION >= 1 && FL_MINOR_VERSION >= 1
# define USE_RGB_IMAGE
#endif

extern VALUE rb_cFLImage;
extern VALUE rb_cFLRGB_Image;

#if !defined(USE_RGB_IMAGE)

class RBFLImage : public Fl_Image {
public:
  RBFLImage(uchar *img, int w, int h, int d = 3, int ld = 0)
    : Fl_Image((const uchar*)img,w,h, d, ld){};
};

#else

class RBFLImage : public Fl_Image {
public:
#if FL_MAJOR_VERSION >= 1 && FL_MINOR_VERSION >= 1
  RBFLImage(int w, int h, int d) : Fl_Image(w,h,d){};
#else
  RBFLImage(int w, int h, int d) : Fl_Image(w,h){};
#endif
};

class RBFLRGB_Image : public Fl_RGB_Image {
public:
  RBFLRGB_Image(uchar *img, int w, int h, int d = 3, int ld = 0)
    : Fl_RGB_Image((const uchar*)img,w,h, d, ld){};
};

#endif /* USE_RGB_IMAGE */

extern "C" void Init_flimage();

#endif /* RBFLIMAGE_H */
