/* -*- C++ -*-
 * $Id: flpixmap.cc,v 1.5 2001/12/04 16:58:33 ttate Exp $
 */

#include "fltk.h"
#include "flwidget.h"
#include "flpixmap.h"

VALUE rb_cFLPixmap;

static void rb_FLPixmap_free(RBFLPixmap *pixmap)
{
};

static VALUE rb_FLPixmap_new(VALUE klass, RBFLPixmap *pixmap)
{
  VALUE obj;
  obj = Data_Wrap_Struct(klass, 0, rb_FLPixmap_free, pixmap);
  rb_fltk_objmap_aset((Fl_Widget*)pixmap, obj);
  return obj;
};

VALUE rb_FLPixmap_initialize(int argc, VALUE argv[], VALUE self)
{
  return Qnil;
};

VALUE rb_FLPixmap_s_new(int argc, VALUE argv[], VALUE klass)
{
  VALUE obj, xpm, str;
  RBFLPixmap *pixmap;
  int ary_len, str_len;
  char **data;
  char **rb_fltk_create_pixmap(VALUE);

  rb_scan_args(argc, argv, "10", &xpm);

  Check_Type(xpm, T_ARRAY);

  data = rb_fltk_create_pixmap(xpm);
  pixmap = new RBFLPixmap(data);
#if FL_MAJOR_VERSION >= 1 && FL_MINOR_VERSION >= 1
  pixmap->alloc_data = 1;
#endif
  obj = rb_FLPixmap_new(klass,pixmap);

  rb_obj_call_init(obj, argc, argv);

  return obj;
};

VALUE rb_FLPixmap_destroy(VALUE self)
{
  RBFLPixmap *pixmap = (RBFLPixmap*)rb_to_fl(self);

  rb_fltk_objmap_delete((Fl_Widget*)pixmap);

#if FL_MAJOR_VERSION >= 1 && FL_MINOR_VERSION >= 1
  if( pixmap ) delete pixmap;
#else
  if( pixmap && pixmap->data ){
    for( int i=0; pixmap->data[i]; i++ ){
      delete[] (pixmap->data[i]);
    };
    free((char**)(pixmap->data));
    delete pixmap;
  };
#endif

  return Qnil;
};

VALUE rb_FLPixmap_label(VALUE self, VALUE vwidget)
{
  RBFLPixmap *pixmap = (RBFLPixmap*)rb_to_fl(self);
  RBFLWidget *widget = (RBFLWidget*)rb_to_fl(vwidget);

  pixmap->label(widget);

  return Qnil;
};

VALUE rb_FLPixmap_draw(int argc, VALUE argv[], VALUE self)
{
  RBFLPixmap *pixmap = (RBFLPixmap*)rb_to_fl(self);
  VALUE arg1, arg2, arg3, arg4, arg5, arg6;
  int x, y, w, h, cx, cy;

  switch( rb_scan_args(argc, argv, "24", &arg1,&arg2,&arg3,&arg4,&arg5,&arg6) ){
  case 2:
    x = NUM2INT(arg1);
    y = NUM2INT(arg2);
    pixmap->draw(x,y);
    break;
  case 4:
    x = NUM2INT(arg1);
    y = NUM2INT(arg2);
    w = NUM2INT(arg3);
    h = NUM2INT(arg4);
    pixmap->draw(x,y,w,h);
    break;
  case 6:
    x = NUM2INT(arg1);
    y = NUM2INT(arg2);
    w = NUM2INT(arg3);
    h = NUM2INT(arg4);
    cx = NUM2INT(arg5);
    cy = NUM2INT(arg6);
    pixmap->draw(x,y,w,h,cx,cy);
    break;
  default:
    rb_raise(rb_eArgError, "too few/many arguments");
  };

  return Qnil;
};

extern "C" void
Init_flpixmap(){
  rb_cFLPixmap = rb_define_class_under(rb_mFLTK, "Pixmap", rb_cObject);
  DEF_S_METHOD(Pixmap, new, -1);
  DEF_METHOD(Pixmap, initialize, -1);
  DEF_METHOD(Pixmap, destroy, 0);
  DEF_METHOD(Pixmap, label, 1);
  DEF_METHOD(Pixmap, draw, -1);
};
