/* -*- C++ -*-
 * $Id: flvaluator.cc,v 1.12 2001/11/30 07:19:14 ttate Exp $
 */

#include "fltk.h"
#include "flvaluator.h"

VALUE rb_cFLValuator;
VALUE rb_cFLAdjuster;
VALUE rb_cFLCounter;
VALUE rb_cFLDial;
VALUE rb_cFLRoller;
VALUE rb_cFLSlider;
VALUE rb_cFLFill_Slider;
VALUE rb_cFLNice_Slider;
VALUE rb_cFLHor_Slider;
VALUE rb_cFLHor_Fill_Slider;
VALUE rb_cFLHor_Nice_Slider;
VALUE rb_cFLScrollbar;
VALUE rb_cFLValue_Slider;
VALUE rb_cFLValue_Input;
VALUE rb_cFLValue_Output;

static FN_S_NEW(Valuator);
WIDGET_FNS(Valuator);
static FN_GETSET_DBL(Valuator,value);
static FN_GETSET_DBL(Valuator,minimum);
static FN_GETSET_DBL(Valuator,maximum);
static FN_SET_DBL2(Valuator,range);
static FN_GET_DBL_SET_DBL(Valuator,round);
static FN_GET_DBL_SET_DBL(Valuator,clamp);
static FN_GET_DBL_SET_DBL_INT(Valuator,increment);
static FN_SET_DBL2(Valuator,bounds);

static VALUE rb_FLValuator_step(int argc, VALUE argv[], VALUE self)
{
  RBFLValuator *widget = (RBFLValuator*)(rb_to_fl(self));
  VALUE arg1, arg2;

  switch( rb_scan_args(argc, argv, "02", &arg1, &arg2) ){
  case 0:
    return rb_float_new(widget->step());
  case 1:
    switch( TYPE(arg1) ){
    case T_FIXNUM:
    case T_BIGNUM:
      widget->step((int)NUM2INT(arg1));
      return Qnil;
    default:
      arg1 = rb_Float(arg1);
      widget->step(RFLOAT(arg1)->value);
      return Qnil;
    };
  case 2:
    arg1 = rb_Float(arg1);
    widget->step(RFLOAT(arg1)->value, FIX2INT(arg2));
    return Qnil;
  };
};

static FN_S_NEW(Adjuster);
WIDGET_FNS(Adjuster);

static FN_S_NEW(Counter);
WIDGET_FNS(Counter);

static FN_S_NEW(Dial);
WIDGET_FNS(Dial);

static FN_S_NEW(Roller);
WIDGET_FNS(Roller);

static FN_S_NEW(Slider);
WIDGET_FNS(Slider);
static FN_GET_INT_SET_INT4(Slider,scrollvalue);

static FN_S_NEW(Nice_Slider);
WIDGET_FNS(Nice_Slider);

static FN_S_NEW(Fill_Slider);
WIDGET_FNS(Fill_Slider);

static FN_S_NEW(Hor_Slider);
WIDGET_FNS(Hor_Slider);

static FN_S_NEW(Hor_Fill_Slider);
WIDGET_FNS(Hor_Fill_Slider);

static FN_S_NEW(Hor_Nice_Slider);
WIDGET_FNS(Hor_Nice_Slider);

static FN_S_NEW(Scrollbar);
WIDGET_FNS(Scrollbar);

static FN_S_NEW(Value_Slider);
WIDGET_FNS(Value_Slider);

static FN_S_NEW(Value_Input);
WIDGET_FNS(Value_Input);

static FN_S_NEW(Value_Output);
WIDGET_FNS(Value_Output);

extern "C" void
Init_flvaluator(){
  rb_cFLValuator = rb_define_class_under(rb_mFLTK, "Valuator", rb_cFLWidget);
  DEF_S_METHOD(Valuator,new,-1);
  DEF_WIDGET_METHODS(Valuator);
  DEF_METHOD_EQ(Valuator,value,-1);
  DEF_METHOD_EQ(Valuator,minimum,-1);
  DEF_METHOD_EQ(Valuator,maximum,-1);
  DEF_METHOD(Valuator,range,2);
  DEF_METHOD_EQ(Valuator,step,-1);
  DEF_METHOD(Valuator,round,-1);
  DEF_METHOD(Valuator,clamp,-1);
  DEF_METHOD(Valuator,increment,-1);
  DEF_METHOD(Valuator,bounds,2);

  rb_cFLAdjuster = rb_define_class_under(rb_mFLTK, "Adjuster", rb_cFLValuator);
  DEF_S_METHOD(Adjuster,new,-1);
  DEF_WIDGET_METHODS(Adjuster);

  rb_cFLCounter = rb_define_class_under(rb_mFLTK, "Counter", rb_cFLValuator);
  DEF_S_METHOD(Counter,new,-1);
  DEF_WIDGET_METHODS(Counter);

  rb_cFLDial = rb_define_class_under(rb_mFLTK, "Dial", rb_cFLValuator);
  DEF_S_METHOD(Dial,new,-1);
  DEF_WIDGET_METHODS(Dial);

  rb_cFLRoller = rb_define_class_under(rb_mFLTK, "Roller", rb_cFLValuator);
  DEF_S_METHOD(Roller,new,-1);
  DEF_WIDGET_METHODS(Roller);

  rb_cFLSlider = rb_define_class_under(rb_mFLTK, "Slider", rb_cFLValuator);
  DEF_S_METHOD(Slider,new,-1);
  DEF_WIDGET_METHODS(Slider);
  DEF_METHOD(Slider,scrollvalue,4);

  rb_cFLFill_Slider = rb_define_class_under(rb_mFLTK, "FillSlider", rb_cFLSlider);
  DEF_S_METHOD(Fill_Slider,new,-1);
  DEF_WIDGET_METHODS(Fill_Slider);

  rb_cFLNice_Slider = rb_define_class_under(rb_mFLTK, "NiceSlider", rb_cFLSlider);
  DEF_S_METHOD(Nice_Slider,new,-1);
  DEF_WIDGET_METHODS(Nice_Slider);

  rb_cFLHor_Slider = rb_define_class_under(rb_mFLTK, "HorSlider", rb_cFLSlider);
  DEF_S_METHOD(Hor_Slider,new,-1);
  DEF_WIDGET_METHODS(Hor_Slider);

  rb_cFLHor_Fill_Slider = rb_define_class_under(rb_mFLTK, "HorFillSlider", rb_cFLSlider);
  DEF_S_METHOD(Hor_Fill_Slider,new,-1);
  DEF_WIDGET_METHODS(Hor_Fill_Slider);

  rb_cFLHor_Nice_Slider = rb_define_class_under(rb_mFLTK, "HorNiceSlider", rb_cFLSlider);
  DEF_S_METHOD(Hor_Nice_Slider,new,-1);
  DEF_WIDGET_METHODS(Hor_Nice_Slider);


  rb_cFLValue_Slider = rb_define_class_under(rb_mFLTK, "ValueSlider", rb_cFLSlider);
  DEF_S_METHOD(Value_Slider,new,-1);
  DEF_WIDGET_METHODS(Value_Slider);

  rb_cFLScrollbar = rb_define_class_under(rb_mFLTK, "Scrollbar", rb_cFLSlider);
  DEF_S_METHOD(Scrollbar,new,-1);
  DEF_WIDGET_METHODS(Scrollbar);

  rb_cFLValue_Input = rb_define_class_under(rb_mFLTK, "ValueInput", rb_cFLValuator);
  DEF_S_METHOD(Value_Input,new,-1);
  DEF_WIDGET_METHODS(Value_Input);

  rb_cFLValue_Output = rb_define_class_under(rb_mFLTK,"ValueOutput",rb_cFLValuator);
  DEF_S_METHOD(Value_Output,new,-1);
  DEF_WIDGET_METHODS(Value_Output);
};
