require 'mkmf'
require 'ftools'

FLLIB = "rubyfltk.so"
GLLIB = "opengl.so"

$ruby_version = CONFIG['MAJOR'] + "." + CONFIG['MINOR']
$prefix = CONFIG['prefix']
$libdir = File.join($prefix,'lib')
$rubylibdir = File.join($libdir, 'ruby', $ruby_version)
$arch = CONFIG['arch']
$archdir = File.join($rubylibdir, $arch)

File::makedirs($rubylibdir, "#{$archdir}")
File::install(FLLIB, "#{$archdir}/#{FLLIB}", 0555, true)
File::install(GLLIB, "#{$archdir}/#{GLLIB}", 0555, true)
File::makedirs("#{$rubylibdir}")
File::makedirs("#{$rubylibdir}/fltk")
File::install("./lib/fltk.rb", "#{$rubylibdir}", 0644, true)
Dir.glob("./lib/fltk/*.rb").each{|f|
  File::install(f, "#{$rubylibdir}/fltk", 0644, true)
}
