require 'fltk'

class MyBrowser < Fltk::Browser_
  include Fltk::Drawable

  def initialize(x,y,w,h,args)
    super(x,y,w,h)
    @items = args.collect{|arg| arg.to_s}
  end

  def item_next(obj)
    @items[@items.index(obj) + 1]
  end

  def item_prev(obj)
    idx = @items.index(obj)
    if( idx > 0 )
      @items[idx - 1]
    else
      nil
    end
  end

  def item_first()
    @items[0]
  end

  def item_draw(obj, x, y, w, h)
    color(Fltk::BLACK)
    text_draw(obj, x, y)
  end

  def item_height(obj)
    15
  end

  def item_width(obj)
    text_width(obj)
  end
end

items = ["one", "two", "three", "four", "five", "six", "seven", "eight"]

w = Fltk::Window.new(0,0,100,100,"Label")
b = MyBrowser.new(5,5,90,90,items)
w.groupend

w.show
Fltk.run
