# NB this require libflek_ui to be linked with ruby-fltk

require 'fltk'

class Test
    def initialize()
        window          = Fltk::Window.new(240,304,"Tree Example")
        removeBtn       = Fltk::Button.new(10,200,100,22,"Remove") { @tree.each_selected() { |node| @tree.remove(node); GC.start } }
        addItemBtn      = Fltk::Button.new(10,224,100,22,"Add Item") { node = @tree.selected
            unless node
                @tree.add_next("Untitled",false)
                break
            end
            @tree.traverse_start(node)
            if node.is_open and node.can_open
                @tree.add_sub("Untitled",false)
            else
                @tree.add_next("Untitled",false)
            end
        }
        addFolderBtn    = Fltk::Button.new(10,248,100,22,"Add Folder") { node = @tree.selected
            unless node
                @tree.add_next("Untitled",true)
                break
            end
            @tree.traverse_start(node)
            if node.is_open and node.can_open
                @tree.add_sub("Untitled",true)
            else
                @tree.add_next("Untitled",true)
            end
        }
        drawLinesBtn    = Fltk::Button.new(10,272,100,22,"Draw Lines") { @tree.draw_lines(!@tree.draw_lines); @tree.redraw }
        #sortBtn         = Fltk::Button.new(130,200,100,22,"Sort") {@tree.sort_by_label(@tree.first, @tree.last); @tree.redraw}
        #reverseSortBtn  = Fltk::Button.new(130,224,100,22,"Reverse Sort") {}
        #randomizeBtn    = FLTK::Button.new(130, 248, 100, 22, "Randomize") {}
        macColorsBtn    = FLTK::Button.new(130,272,100,22,"Mac Colors") { if @tree.alternate_color() == @tree.color()
                @tree.alternate_color(FLTK::LIGHT1)
                @tree.trim_color(FLTK::LIGHT2)
                @tree.redraw
            else
                @tree.alternate_color(@tree.color())
                @tree.trim_color(@tree.color())
                @tree.redraw
            end
        }
        scroll           = FLTK::Scroll.new(10,10,220,180)
        #scroll.scroll_type(FLTK::Scroll::VERTICAL_ALWAYS)
        @tree            = FLTK::ToggleTree.new(12,12,200,10)
        @tree.edit_callback() { |widget| widget.end_edit; GC.start }
        scroll.group_end
        window.show
        FLTK::run()
    end
end

t = Test.new
